#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>
#include <dirent.h>
#include <string.h>
              
#include "parse.h"
#include "stdlib.h"

char * data_path;
char * data_file;

char * database_index;
char * translate_table;
char * database_file;

void set_index(char * what) 
{
  strcpy(database_index, what);
}

void set_translate(char * what) 
{
  strcpy(translate_table, what);
}

void set_database(char * what) 
{
  strcpy(database_file, what);
}

int write_data_file()
{
  return 0;
}

int slovnik_dir_exist(char * home)
{
  DIR * tempdir;
  if (home) {
    tempdir=opendir(home);
    if (tempdir) {
      closedir(tempdir);
      return 1;
    } else {
      return 0;
    }
  }
  return 0;
}  

int read_from_config_file()
{
  database_index = malloc(200);
  translate_table = malloc(200);
  database_file = malloc(200);
        
  database_index = read_config_file(data_file,"index");
  if (database_index) printf("index: %s\n",database_index);                                        
  else printf("chyba\n");                                                       

  database_file = read_config_file(data_file,"database");
  if (database_file) printf("database: %s\n",database_file);
  else printf("chyba\n");

  translate_table = read_config_file(data_file,"translate");
  if (translate_table) printf("translate: %s\n",translate_table);
  else printf("chyba\n");                                                       

  return 1;
}

char * return_config_file ()
{
  char * home;
  char * data_dir;
  char * global_data_file;
  char * local_data_file;
  
  char is_home;

  data_path = malloc(200);
  global_data_file = malloc(200);
  local_data_file = malloc(200);
  data_dir = malloc(200);

 //home = malloc(200);

  home = getenv ("HOME");
  if (home) {
    printf("home is %s\n", home);
   is_home=1;
  } else {
    printf("homeless\n");
   is_home=0;
  } 
  
  data_file = malloc(200);

  //check for global datafile
  if (exist("/usr/local/share/slovnik/data/slovnik.dat")) {
    printf ("global datafile exists ...\n");
    strcpy(global_data_file,"/usr/local/share/slovnik/data/slovnik.dat");
  } else {
    global_data_file[0]=0;
  }
  
  if (is_home) {
    strcpy (data_dir,home);
    strcat (data_dir,"/.slovnik");

    if (!slovnik_dir_exist(data_dir)) {
      mkdir(data_dir);
      printf("creating local data directory %s\n", data_dir);
    }

    strcpy (local_data_file,home);
    strcat (local_data_file,"/.slovnik/slovnikrc");
    printf ("local datafile is %s\n", local_data_file);

    if(exist(local_data_file)) {
      strcpy (data_file, local_data_file);
    } else {
      printf("FIXME: creating local data file \n");
      //read config(global_data)
      //write config (local data)
      //data_file=local_config
      //pokud vse selze tak global config   
    }

  }  

  free(local_data_file);
  free(global_data_file);

  printf("+++ datafile is:%s\n",data_file);
  
  return data_file;        
}

void destructor()
{
/*  free(data_path);
  free(databaseindex);
  free(translate);
  free(database);*/
}
